package jclusim.experiments.simple;

import jclusim.base.Agent;
import jclusim.base.Cell;
import jclusim.base.Item;
import jclusim.util.RandomVariable;
import jclusim.util.Similarity;

public class SimpleAgent extends Agent {

	@Override
	public Cell chooseNextCell() {
		int dx = RandomVariable.drawDiscreteUniform(-1, 1);
		int dy = RandomVariable.drawDiscreteUniform(-1, 1);
		Cell cellOfInterest = getCurrentCell().getNeighbor(dx, dy);
		return cellOfInterest;
	}

	@Override
	public boolean considerPickup() {
		Cell currentCell = getCurrentCell();
		Item laidItem = currentCell.getLaidItem();
		double density = Similarity.COSINUS
				.computeAveragedSimilarityWithNeigbhorhood(laidItem, 1,
						currentCell);
		double probability = 1 - density;
		return RandomVariable.drawContinuousUniform() < probability;

	}

	@Override
	public boolean considerDrop() {
		double density = Similarity.COSINUS
				.computeAveragedSimilarityWithNeigbhorhood(getCarriedItem(), 1,
						getCurrentCell());
		double probability = density;
		return RandomVariable.drawContinuousUniform() < probability;
	}
}
