package jclusim.observer.metric;

import jclusim.base.Experiment;
import jclusim.base.Item;
import jclusim.util.Similarity;

public class Homogeneity implements IMetric {

    private Similarity measure;

    public Homogeneity(Similarity measure) {
	super();
	this.measure = measure;
    }

    public double computeValue(Experiment exp) {

	int laidObjects = 0;
	double totalDensity = 0.0;
	for (int i = 0; i < exp.getObjects().length; i++) {
	    Item obj = exp.getObjects()[i];
	    if (obj.isLaid()) {
		totalDensity += measure.computeAveragedSimilarityWithNeigbhorhood(obj,
			1, obj.getCell());
		laidObjects++;
	    }
	}

	return (totalDensity / laidObjects);
    }

    @Override
    public String toString() {
	return "Homogeneity <" + measure.toString() + ">";
    }

}
