package jclusim.ui;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.RenderingHints;
import java.util.Observable;
import java.util.Observer;

import javax.swing.JPanel;

import jclusim.observer.ExperimentObserver;

public class ExperimentObserverPanel extends JPanel implements Observer {

    private static final long serialVersionUID = -2124322891840850180L;
    private ExperimentObserver experimentObserver;

    protected ExperimentObserverPanel(ExperimentObserver imageExporter) {
	this.experimentObserver = imageExporter;
	this.setPreferredSize(new Dimension(experimentObserver
		.getCanevasWidth(), experimentObserver.getCanevasHeight()));
	experimentObserver.addObserver(this);
	this.setBackground(Color.BLACK);
    }

    public void update(Observable o, Object arg) {
	repaint();
    }

    @Override
    protected void paintComponent(Graphics g) {
	super.paintComponent(g);
	Graphics2D g2d = (Graphics2D) g;
	g2d.setRenderingHint(RenderingHints.KEY_INTERPOLATION,
		RenderingHints.VALUE_INTERPOLATION_BILINEAR);
	double sx = getSize().getWidth()
		/ ((double) experimentObserver.getCanevasWidth());
	double sy = getSize().getHeight()
		/ ((double) experimentObserver.getCanevasHeight());
	g2d.scale(sx, sy);
	experimentObserver.renderState(g2d);
    }

}
