package jclusim.ui;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.util.ArrayList;
import java.util.Iterator;

import javax.swing.JFrame;
import javax.swing.JPanel;

import jclusim.observer.ExperimentObserver;

public class JClusimFrame extends JFrame {

    private static final long serialVersionUID = -6344050560699145812L;

    public JClusimFrame(ArrayList<ExperimentObserver> expObservers) {
	this.setTitle("JClusim");
	this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
	this.setLayout(new GridBagLayout());
	for (Iterator<ExperimentObserver> it = expObservers.iterator(); it
		.hasNext();) {
	    GridBagConstraints cons = new GridBagConstraints();
	    cons.gridx = 0;
	    JPanel expPanel = new ExperimentObserverPanel(it.next());
	    this.add(expPanel, cons);
	}
	this.pack();
    }
}
